using System.Net.Http;
using System.Text;
using System.Threading.Tasks;
using Hncore.Infrastructure.Common;
using Hncore.Infrastructure.Serializer;
using Hncore.Pass.PaymentCenter.WeiFuTong.QrPay;

namespace Hncore.Pass.PaymentCenter.WeiFuTong.ClientExtension
{
    public static class QrPay
    {
        /// <summary>
        /// 扫码支付下单
        /// </summary>
        /// <param name="weiFuTongClient"></param>
        /// <param name="request"></param>
        /// <returns></returns>
        public static async Task<QrPayCreateOrderResponse> QrPayCreateOrderAsync(this WeiFuTongClient weiFuTongClient
            , QrPayCreateOrderRequest request)
        {
            StringBuilder log = new StringBuilder();

            var body = request.ToXml();

            log.Append("请求：\r\n" + body);

            var response = await weiFuTongClient.CreateHttpClient()
                .PostAsync(request.PaymentChannel.GetUrl(), new StringContent(body));

            var resText = await response.Content.ReadAsStringAsync();

            log.Append("\r\n响应：" + resText);

            string target = "";

            if (request.Service == "pay.weixin.native")
            {
                target = "微信";
            }
            else if (request.Service == "pay.alipay.native")
            {
                target = "支付宝";
            }

            LogHelper.Trace($"威富通-{target}扫码支付下单", log.ToString());

            Util.CheckSignFromXml(resText, request.MchInfo);

            var res = XML.XmlDeserialize<QrPayCreateOrderResponse>(resText);

            res.HandleError();

            return res;
        }
    }
}